require 'helper'

class OpenLDAPMonitorInputTest < Test::Unit::TestCase
  CONFIG = %[
    tag test
    host test.test
    bind_dn cn=Admin,cn=Monitor
    bind_password secret
  ]
  ENTRIES = [{:dn=>['cn=Monitor'], :structuralobjectclass=>['monitorServer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['OpenLDAP: slapd 2.4.35 (May 16 2014 08:17:57)'], :entrydn=>['cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Backends,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['config', 'ldif', 'monitor', 'ldap', 'mdb', 'perl', 'relay'], :entrydn=>['cn=Backends,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Backend 0,cn=Backends,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['config'], :monitorruntimeconfig=>['TRUE'], :supportedcontrol=>['2.16.840.1.113730.3.4.2'], :entrydn=>['cn=Backend 0,cn=Backends,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Backend 1,cn=Backends,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['ldif'], :monitorruntimeconfig=>['TRUE'], :supportedcontrol=>['2.16.840.1.113730.3.4.2'], :entrydn=>['cn=Backend 1,cn=Backends,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Backend 2,cn=Backends,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['monitor'], :monitorruntimeconfig=>['TRUE'], :supportedcontrol=>['2.16.840.1.113730.3.4.2'], :entrydn=>['cn=Backend 2,cn=Backends,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Backend 3,cn=Backends,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['ldap'], :monitorruntimeconfig=>['TRUE'], :entrydn=>['cn=Backend 3,cn=Backends,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Backend 4,cn=Backends,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['mdb'], :monitorruntimeconfig=>['TRUE'], :supportedcontrol=>['1.3.6.1.1.12', '2.16.840.1.113730.3.4.2', '1.3.6.1.4.1.4203.666.5.2', '1.2.840.113556.1.4.319', '1.3.6.1.1.13.1', '1.3.6.1.1.13.2', '1.3.6.1.4.1.4203.1.10.1', '1.2.840.113556.1.4.1413'], :entrydn=>['cn=Backend 4,cn=Backends,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Backend 5,cn=Backends,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['perl'], :monitorruntimeconfig=>['TRUE'], :entrydn=>['cn=Backend 5,cn=Backends,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Backend 6,cn=Backends,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['relay'], :monitorruntimeconfig=>['TRUE'], :entrydn=>['cn=Backend 6,cn=Backends,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Connections,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=Connections,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Connection 1427,cn=Connections,cn=Monitor'], :structuralobjectclass=>['monitorConnection'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519054541Z'], :modifytimestamp=>['20140519054541Z'], :monitorconnectionnumber=>['1427'], :monitorconnectionprotocol=>['3'], :monitorconnectionopsreceived=>['2'], :monitorconnectionopsexecuting=>['1'], :monitorconnectionopspending=>['0'], :monitorconnectionopscompleted=>['1'], :monitorconnectionget=>['2'], :monitorconnectionread=>['2'], :monitorconnectionwrite=>['0'], :monitorconnectionmask=>['rx'], :monitorconnectionauthzdn=>['cn=Admin,cn=Monitor'], :monitorconnectionlistener=>['ldap://0.0.0.0:389'], :monitorconnectionpeerdomain=>['unknown'], :monitorconnectionpeeraddress=>['IP=10.0.2.2:49242'], :monitorconnectionlocaladdress=>['IP=0.0.0.0:389'], :monitorconnectionstarttime=>['20140519054541Z'], :monitorconnectionactivitytime=>['20140519054541Z'], :entrydn=>['cn=Connection 1427,cn=Connections,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Max File Descriptors,cn=Connections,cn=Monitor'], :structuralobjectclass=>['monitorCounterObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorcounter=>['1024'], :entrydn=>['cn=Max File Descriptors,cn=Connections,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Total,cn=Connections,cn=Monitor'], :structuralobjectclass=>['monitorCounterObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorcounter=>['1428'], :entrydn=>['cn=Total,cn=Connections,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Current,cn=Connections,cn=Monitor'], :structuralobjectclass=>['monitorCounterObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorcounter=>['1'], :entrydn=>['cn=Current,cn=Connections,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Databases,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :readonly=>['FALSE'], :namingcontexts=>['', 'cn=config'], :monitorcontext=>['cn=Monitor'], :entrydn=>['cn=Databases,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Frontend,cn=Databases,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['frontend'], :monitorisshadow=>['FALSE'], :namingcontexts=>[''], :readonly=>['FALSE'], :entrydn=>['cn=Frontend,cn=Databases,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Database 0,cn=Databases,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['config'], :monitorisshadow=>['FALSE'], :namingcontexts=>['cn=config'], :readonly=>['FALSE'], :entrydn=>['cn=Database 0,cn=Databases,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Database 1,cn=Databases,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['monitor'], :monitorisshadow=>['FALSE'], :monitorcontext=>['cn=Monitor'], :readonly=>['FALSE'], :entrydn=>['cn=Database 1,cn=Databases,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Listeners,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=Listeners,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Listener 0,cn=Listeners,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorconnectionlocaladdress=>['IP=0.0.0.0:389'], :entrydn=>['cn=Listener 0,cn=Listeners,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Log,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=Log,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['856'], :monitoropcompleted=>['855'], :entrydn=>['cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Bind,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['428'], :monitoropcompleted=>['428'], :entrydn=>['cn=Bind,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Unbind,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['0'], :monitoropcompleted=>['0'], :entrydn=>['cn=Unbind,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Search,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['428'], :monitoropcompleted=>['427'], :entrydn=>['cn=Search,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Compare,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['0'], :monitoropcompleted=>['0'], :entrydn=>['cn=Compare,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Modify,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['0'], :monitoropcompleted=>['0'], :entrydn=>['cn=Modify,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Modrdn,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['0'], :monitoropcompleted=>['0'], :entrydn=>['cn=Modrdn,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Add,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['0'], :monitoropcompleted=>['0'], :entrydn=>['cn=Add,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Delete,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['0'], :monitoropcompleted=>['0'], :entrydn=>['cn=Delete,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Abandon,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['0'], :monitoropcompleted=>['0'], :entrydn=>['cn=Abandon,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Extended,cn=Operations,cn=Monitor'], :structuralobjectclass=>['monitorOperation'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoropinitiated=>['0'], :monitoropcompleted=>['0'], :entrydn=>['cn=Extended,cn=Operations,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Overlays,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['glue', 'syncprov', 'rwm', 'distproc', 'pbind', 'chain'], :entrydn=>['cn=Overlays,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Overlay 0,cn=Overlays,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['glue'], :monitorruntimeconfig=>['FALSE'], :entrydn=>['cn=Overlay 0,cn=Overlays,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Overlay 1,cn=Overlays,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['syncprov'], :monitorruntimeconfig=>['TRUE'], :entrydn=>['cn=Overlay 1,cn=Overlays,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Overlay 2,cn=Overlays,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['rwm'], :monitorruntimeconfig=>['TRUE'], :entrydn=>['cn=Overlay 2,cn=Overlays,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Overlay 3,cn=Overlays,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['distproc'], :monitorruntimeconfig=>['TRUE'], :entrydn=>['cn=Overlay 3,cn=Overlays,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Overlay 4,cn=Overlays,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['pbind'], :monitorruntimeconfig=>['TRUE'], :entrydn=>['cn=Overlay 4,cn=Overlays,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Overlay 5,cn=Overlays,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['chain'], :monitorruntimeconfig=>['TRUE'], :entrydn=>['cn=Overlay 5,cn=Overlays,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=SASL,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=SASL,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Statistics,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=Statistics,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Bytes,cn=Statistics,cn=Monitor'], :structuralobjectclass=>['monitorCounterObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorcounter=>['11066756'], :entrydn=>['cn=Bytes,cn=Statistics,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=PDU,cn=Statistics,cn=Monitor'], :structuralobjectclass=>['monitorCounterObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorcounter=>['27532'], :entrydn=>['cn=PDU,cn=Statistics,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Entries,cn=Statistics,cn=Monitor'], :structuralobjectclass=>['monitorCounterObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorcounter=>['26678'], :entrydn=>['cn=Entries,cn=Statistics,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Referrals,cn=Statistics,cn=Monitor'], :structuralobjectclass=>['monitorCounterObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorcounter=>['0'], :entrydn=>['cn=Referrals,cn=Statistics,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Max,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['16'], :entrydn=>['cn=Max,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Max Pending,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['0'], :entrydn=>['cn=Max Pending,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Open,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['2'], :entrydn=>['cn=Open,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Starting,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['0'], :entrydn=>['cn=Starting,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Active,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['1'], :entrydn=>['cn=Active,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Pending,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['0'], :entrydn=>['cn=Pending,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Backload,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['1'], :entrydn=>['cn=Backload,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=State,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['unknown'], :entrydn=>['cn=State,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Runqueue,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=Runqueue,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Tasklist,cn=Threads,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=Tasklist,cn=Threads,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Time,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=Time,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Start,cn=Time,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitortimestamp=>['20140519050502Z'], :entrydn=>['cn=Start,cn=Time,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Current,cn=Time,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitortimestamp=>['20140519054541Z'], :entrydn=>['cn=Current,cn=Time,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Uptime,cn=Time,cn=Monitor'], :structuralobjectclass=>['monitoredObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitoredinfo=>['2439'], :entrydn=>['cn=Uptime,cn=Time,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=TLS,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=TLS,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Waiters,cn=Monitor'], :structuralobjectclass=>['monitorContainer'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :entrydn=>['cn=Waiters,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['TRUE']}, {:dn=>['cn=Read,cn=Waiters,cn=Monitor'], :structuralobjectclass=>['monitorCounterObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorcounter=>['1'], :entrydn=>['cn=Read,cn=Waiters,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}, {:dn=>['cn=Write,cn=Waiters,cn=Monitor'], :structuralobjectclass=>['monitorCounterObject'], :creatorsname=>['cn=Admin,cn=Monitor'], :modifiersname=>['cn=Admin,cn=Monitor'], :createtimestamp=>['20140519050502Z'], :modifytimestamp=>['20140519050502Z'], :monitorcounter=>['0'], :entrydn=>['cn=Write,cn=Waiters,cn=Monitor'], :subschemasubentry=>['cn=Subschema'], :hassubordinates=>['FALSE']}]

  def create_driver(conf = CONFIG)
    Fluent::Test::InputTestDriver.new(Fluent::OpenLDAPMonitorInput).configure(conf)
  end

  def test_convert_entries
    d = create_driver
    entries = d.instance.convert_entries(ENTRIES)
    assert_equal entries, {:monitor=>{:monitoredinfo=>'OpenLDAP: slapd 2.4.35 (May 16 2014 08:17:57)', :backends=>{:monitoredinfo=>['config', 'ldif', 'monitor', 'ldap', 'mdb', 'perl', 'relay'], :backend_0=>{:monitoredinfo=>'config', :monitorruntimeconfig=>true, :supportedcontrol=>'2.16.840.1.113730.3.4.2'}, :backend_1=>{:monitoredinfo=>'ldif', :monitorruntimeconfig=>true, :supportedcontrol=>'2.16.840.1.113730.3.4.2'}, :backend_2=>{:monitoredinfo=>'monitor', :monitorruntimeconfig=>true, :supportedcontrol=>'2.16.840.1.113730.3.4.2'}, :backend_3=>{:monitoredinfo=>'ldap', :monitorruntimeconfig=>true}, :backend_4=>{:monitoredinfo=>'mdb', :monitorruntimeconfig=>true, :supportedcontrol=>['1.3.6.1.1.12', '2.16.840.1.113730.3.4.2', '1.3.6.1.4.1.4203.666.5.2', '1.2.840.113556.1.4.319', '1.3.6.1.1.13.1', '1.3.6.1.1.13.2', '1.3.6.1.4.1.4203.1.10.1', '1.2.840.113556.1.4.1413']}, :backend_5=>{:monitoredinfo=>'perl', :monitorruntimeconfig=>true}, :backend_6=>{:monitoredinfo=>'relay', :monitorruntimeconfig=>true}}, :connections=>{:connection_1427=>{:monitorconnectionnumber=>1427, :monitorconnectionprotocol=>3, :monitorconnectionopsreceived=>2, :monitorconnectionopsexecuting=>1, :monitorconnectionopspending=>0, :monitorconnectionopscompleted=>1, :monitorconnectionget=>2, :monitorconnectionread=>2, :monitorconnectionwrite=>0, :monitorconnectionmask=>'rx', :monitorconnectionauthzdn=>'cn=Admin,cn=Monitor', :monitorconnectionlistener=>'ldap://0.0.0.0:389', :monitorconnectionpeerdomain=>'unknown', :monitorconnectionpeeraddress=>'IP=10.0.2.2:49242', :monitorconnectionlocaladdress=>'IP=0.0.0.0:389', :monitorconnectionstarttime=>'20140519054541Z', :monitorconnectionactivitytime=>'20140519054541Z'}, :max_file_descriptors=>{:monitorcounter=>1024}, :total=>{:monitorcounter=>1428}, :current=>{:monitorcounter=>1}}, :databases=>{:readonly=>false, :namingcontexts=>['', 'cn=config'], :monitorcontext=>'cn=Monitor', :frontend=>{:monitoredinfo=>'frontend', :monitorisshadow=>false, :namingcontexts=>'', :readonly=>false}, :database_0=>{:monitoredinfo=>'config', :monitorisshadow=>false, :namingcontexts=>'cn=config', :readonly=>false}, :database_1=>{:monitoredinfo=>'monitor', :monitorisshadow=>false, :monitorcontext=>'cn=Monitor', :readonly=>false}}, :listeners=>{:listener_0=>{:monitorconnectionlocaladdress=>'IP=0.0.0.0:389'}}, :log=>{}, :operations=>{:monitoropinitiated=>856, :monitoropcompleted=>855, :bind=>{:monitoropinitiated=>428, :monitoropcompleted=>428}, :unbind=>{:monitoropinitiated=>0, :monitoropcompleted=>0}, :search=>{:monitoropinitiated=>428, :monitoropcompleted=>427}, :compare=>{:monitoropinitiated=>0, :monitoropcompleted=>0}, :modify=>{:monitoropinitiated=>0, :monitoropcompleted=>0}, :modrdn=>{:monitoropinitiated=>0, :monitoropcompleted=>0}, :add=>{:monitoropinitiated=>0, :monitoropcompleted=>0}, :delete=>{:monitoropinitiated=>0, :monitoropcompleted=>0}, :abandon=>{:monitoropinitiated=>0, :monitoropcompleted=>0}, :extended=>{:monitoropinitiated=>0, :monitoropcompleted=>0}}, :overlays=>{:monitoredinfo=>['glue', 'syncprov', 'rwm', 'distproc', 'pbind', 'chain'], :overlay_0=>{:monitoredinfo=>'glue', :monitorruntimeconfig=>false}, :overlay_1=>{:monitoredinfo=>'syncprov', :monitorruntimeconfig=>true}, :overlay_2=>{:monitoredinfo=>'rwm', :monitorruntimeconfig=>true}, :overlay_3=>{:monitoredinfo=>'distproc', :monitorruntimeconfig=>true}, :overlay_4=>{:monitoredinfo=>'pbind', :monitorruntimeconfig=>true}, :overlay_5=>{:monitoredinfo=>'chain', :monitorruntimeconfig=>true}}, :sasl=>{}, :statistics=>{:bytes=>{:monitorcounter=>11066756}, :pdu=>{:monitorcounter=>27532}, :entries=>{:monitorcounter=>26678}, :referrals=>{:monitorcounter=>0}}, :threads=>{:max=>{:monitoredinfo=>16}, :max_pending=>{:monitoredinfo=>0}, :open=>{:monitoredinfo=>2}, :starting=>{:monitoredinfo=>0}, :active=>{:monitoredinfo=>1}, :pending=>{:monitoredinfo=>0}, :backload=>{:monitoredinfo=>1}, :state=>{:monitoredinfo=>'unknown'}, :runqueue=>{}, :tasklist=>{}}, :time=>{:start=>{}, :current=>{}, :uptime=>{:monitoredinfo=>2439}}, :tls=>{}, :waiters=>{:read=>{:monitorcounter=>1}, :write=>{:monitorcounter=>0}}}}
  end
end
